<template>
  <VForm name="user-list-filter" :fields="fields" @field-input="onFieldInput" @button="onButton" @submit="onSubmit" />
</template>

<script>
const DEFAULT_VALUE = '-lastloggedon'

import { ref } from 'vue'
import { useRouter, useRoute } from 'vue-router'
import { StringHelper, VForm } from '../../../core'
import { useUserAddOn } from '../../plugins/user-add-on-plugin.js'

export default {
  name: 'UserListFilter',
  components: {
    VForm,
  },
  props: {
    filter: { type: String, default: '' },
    sort: { type: String, default: '' },
  },
  setup(props) {
    const router = useRouter()
    const route = useRoute()
    const userAddOn = useUserAddOn()

    const getSortDesc = (sort) => {
      const value = StringHelper.emptyToDefault(sort, DEFAULT_VALUE)
      return value.charAt(0) === '-' ? '-' : ''
    }

    const getSortField = (sort) => {
      const value = StringHelper.emptyToDefault(sort, DEFAULT_VALUE)
      return value.charAt(0) === '-' ? value.substring(1) : value
    }

    const fields = ref([
      {
        type: 'text',
        name: 'filter',
        placeholder: 'Search by username',
        maxlength: 255,
        buttonIconClass: 'bi bi-search',
        value: props.filter,
      },
      {
        type: 'select',
        name: 'sortfield',
        value: getSortField(props.sort),
        options: userAddOn.filters.map((x) => ({ text: `Sort by ${x.text}`, value: x.value })),
      },
      {
        type: 'radio',
        inline: true,
        name: 'sortdesc',
        value: getSortDesc(props.sort),
        options: [
          { value: '', text: 'Ascending' },
          { value: '-', text: 'Descending' },
        ],
      },
    ])

    const getSort = (sortDesc, sortField) => {
      const value = sortDesc + sortField
      return value === DEFAULT_VALUE ? '' : value
    }

    const onButton = (field, form) => {
      submitForm(form)
    }

    const onFieldInput = (field, form) => {
      if (field.name !== 'filter') {
        submitForm(form)
      }
    }

    const onSubmit = (form) => {
      submitForm(form)
    }

    const submitForm = (form) => {
      const query = {}

      if (form.filter) {
        query.filter = form.filter
      }

      const sort = getSort(form.sortdesc, form.sortfield)
      if (sort) {
        query.sort = sort
      }

      router.push({ path: route.path, query: query })
    }

    return {
      fields,
      onButton,
      onFieldInput,
      onSubmit,
    }
  },
}
</script>
